#include "Huizhang.h"
#include <SoftwareSerial.h>

HuiZhang::HuiZhang(uint8_t port0, uint8_t port)
{
    _HuiZhang_pin0 = port0;
    _HuiZhang_pin = port;
    #if defined(ESP_PLATFORM)
        Serial2.begin(19200, _HuiZhang_pin0, _HuiZhang_pin);
    #endif
}

void HuiZhang::write(String a, bool b)
{
    #if defined(ESP_PLATFORM)
        b ? Serial2.println(a) : Serial2.print(a);
        delayMicroseconds(28);
    #else
        #ifndef softwareSerial1
            SoftwareSerial softwareSerial1(_HuiZhang_pin0, _HuiZhang_pin);
            softwareSerial1.begin(19200);
        #endif
        b ? softwareSerial1.println(a) : softwareSerial1.print(a);
        #if defined(NRF5)
            delayMicroseconds(24);//不同CPU延时时间mega328 (25)  Microbit (24)  M0和ESP32(28)
        #else
            delayMicroseconds(25);
        #endif
    #endif
}

// void HuiZhang::writehex(uint16_t a)
// {
//     #if defined(ESP_PLATFORM)
//         Serial1.begin(115200, P0, _HuiZhang_pin);
//         Serial1.print(a);
//     #else
//         #ifndef softwareSerial1/
//             SoftwareSerial softwareSerial1(3, _HuiZhang_pin);
//             softwareSerial1.begin(115200);
//         #endif
//             softwareSerial1.print(a);
//     #endif
//     delay(1);
// }

void HuiZhang::SendClr()
{
    write("hc",1);
}

void HuiZhang::SendNum(String a)
{
    write(String("hn"+a),1);
}

void HuiZhang::SendNumAtX(String a, uint8_t x)
{
    write("hn"+String(x)+"/"+a,1);
}

void HuiZhang::SendStr(String a)
{
    write("hs"+a,1);
}

void HuiZhang::SendStrAtX(String a, uint8_t x)
{
    write("hs"+String(x)+"/"+a,1);
}

void HuiZhang::SendMatrixAxis(uint8_t x, uint8_t y)
{
    write("hmx"+String(x)+"y"+String(y)+"/",0);
}

void HuiZhang::SendMatrix(String c)
{
    write(c, 0);
}

void HuiZhang::SendMatrixDisplay()
{
    write("",1);
}
